/* Program average.cc    */
/* By Harald Stauss      */
/* Last change 28.02.99  */

#include <ctype.h>
#include "tsa.h"

main(int argc, char *argv[])
{
  short          i, j, ndat, is_norm;
  float          wert;
  unsigned long  n;
  char           *fin, *fout, *ftin, *ftout;
  char           *pftin, *pftout;
  REGIST         r[20], f;

  /* H e l l o   w o r l d */
  cout << "average Ver.1.2 by H. Stauss, 1999 \n";

  /* A r r a y s   a l l o c i e r e n */
  fin  =new char[256];
  fout =new char[256];
  ftin =new char[256];
  ftout=new char[256];

  /* P a r a m e t e r   e i n l e s e n */
  if ((argc<5) || (argc>23)) {
    cout << "number of parameters wrong! \n";
    cout << "average fin1 fin2 fin3 ... fout normalize \n";
    cout << "fin      : minimum 2 and maximum 20 input files ! \n";
    cout << "fout     : output file name \n";
    cout << "normalize: 0: do not normalize input files before averaging \n";
    cout << "normalize: 1: normalize input files before averaging \n";
    goto ende;
  }
  ndat=argc-3;
  cout << "number of data files: " << ndat << "\n";
  strcpy(fout,argv[ndat+1]);
  strcpy(ftout,fout);
  pftout=strrchr(ftout,'.');
  for (j=0; pftout[j]; j++) pftout[j]=toupper(pftout[j]);
  cout << "output file : " << fout << " \n";
  for (i=0; i<ndat; i++) {
    strcpy(fin,argv[i+1]);
    strcpy(ftin,fin);
    pftin=strrchr(ftin,'.');
    for (j=0; pftin[j]; j++) pftin[j]=toupper(pftin[j]);
    cout << "input file : " << fin << " \n";

    /* E i n g a b e d a t e i e n   o e f f n e n */
    if (strcmp(pftin,".TSA")==0) r[i].ReadTSA(fin);
    if (strcmp(pftin,".ASC")==0) r[i].ReadASCII(fin,1);
    if ((strcmp(pftin,".TSA")!=0) && (strcmp(pftin,".ASC")!=0)) {
      cout << "File type for input file " << i+1 << "  not recognized! \n";
      goto ende;
    }
    cout << "Number of channels in file " << i+1 << ": " << r[i].n << "\n";
  }

  is_norm=atoi(argv[ndat+2]);
  if (is_norm) cout << "input files will be normalized \n";
  else         cout << "input files will not be normalized \n";

  for (i=0; i<r[0].n; i++) {
    f.AddChannel(r[0].ch[i].n, r[0].ch[i].sr, r[0].ch[i].min, r[0].ch[i].max,
		 r[0].ch[i].height, r[0].ch[i].color,
		 r[0].ch[i].name, r[0].ch[i].unit);
  }

  /* N o r m a l i z e */
  if (is_norm) {
    for (j=0; j<ndat; j++) {
      for (i=0; i<r[j].n; i++) {
	wert=0;
	for (n=0; n<r[j].ch[i].n; n++) {
	  wert+=r[j].ch[i].data[n];
	}
	for (n=0; n<r[j].ch[i].n; n++) {
	  r[j].ch[i].data[n]=100*r[j].ch[i].data[n]/wert;
	}
      }
    }
  }    

    /* M A I N L O O P  */
    for (i=0; i<r[0].n; i++) {               // Kanaele;
      for (n=0; n<r[0].ch[i].n; n++) {       // Messwerte;
	wert=0;
	for (j=0; j<ndat; j++) {               // Dateien;
	  wert+=r[j].ch[i].data[n];
	}
	f.ch[i].data[n]=wert/ndat;
      }
    } /* endfor */


    /* D a t e i   s c h r e i b e n */
    if (strcmp(pftout,".TSA")==0) f.WriteTSA(fout);
    if (strcmp(pftout,".ASC")==0) f.WriteASCII(fout);
    if ((strcmp(pftout,".TSA")!=0) && (strcmp(pftout,".ASC")!=0)) {
      cout << "File type for output not recognized! \n";
      goto ende;
    }

  ende:
    delete[]fin; delete[]ftin; delete[]fout; delete[]ftout;
    return(0);
  } /* Ende von main */
