/*******************************************************/
/* Linux  GNU     C++ Compiler                         */
/* Name : tsa.h                                        */
/* Autor: Harald Stauss                                */
/*******************************************************/

#ifndef TSA

#define TSA

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <iostream.h>
#include <fstream.h>

class   REGIST {
  typedef struct {
    float  *data;		/* data for channel */
    float  sr;			/* sampling rate */
    float  min,max;             /* min und max */
    int    height, color;       /* height and color of channel */
    unsigned long   n;		/* number of values in channel */
    char   name[80],unit[80];   /* name and unit of channel */
  }
  CHANNEL;

  typedef struct {
    unsigned int  n;             /* number of comments */
    unsigned long *time;         /* array of time of comments in seconds */
    char          **comment;     /* array of comments */
  }
  COMMENTS;

 public:
  short    n;			/* number of channels */
  CHANNEL  *ch;			/* channels */
  COMMENTS *comments;           /* comments */

  // Initialisierung der Registrierung;
  REGIST();   // Constructor;
  ~REGIST();  // Destructor;

  // function to read ASCII files from value number s to e;
  int ReadASCII(char *fname, float sr=1, char delim='\t',
		unsigned long bc=1,
		unsigned long ec=0,
		unsigned long br=1,
		unsigned long er=0);

  // function to write ASCII files;
  int WriteASCII(char *fname, char delim='\t',
		 unsigned long bc=1,
		 unsigned long ec=0,
		 unsigned long br=1,
		 unsigned long er=0);
  
  // function to read TSA files (new format);
  int ReadTSA(char *fname);

  // function to write TSA files (new format);
  int WriteTSA(char *fname);

  // function to read MAD files;
  int ReadMAD(char *fname);

  // function to read WAV files;
  int ReadWAV(char *fname);

  // function to add new channel;
  virtual  int AddChannel(unsigned long ndata,
			  float sr=1, float min=0, float max=1,
			  int height=0, int color=0,
			  char *name="channel", char *unit="unit");

  // function to delete channel;
  virtual  int DelChannel(short nch);
  
}; /* Ende der Klassendefinition */

#endif
